%YAML 1.1
---
gfVersion: v2.0
class: app

name: bowtie2-build-gf2
description: Bowtie2 build
git: https://gitlab.com/geneflow/apps/bowtie2-build-gf2.git
version: '2.4.1-01'

inputs:
  reference:
    label: Reference Sequence FASTA File
    description: Reference sequence FASTA file
    type: File
    required: true
    test_value: ${SCRIPT_DIR}/data/poliovirus_strain_Sabin1.fasta

parameters:
  threads:
    label: CPU Threads
    description: Number of CPU threads used for building index
    type: int
    default: 2
    required: false
    test_value: 2

  output:
    label: Output Folder
    description: Output folder
    type: Directory
    required: true
    test_value: reference

pre_exec:
- run: mkdir -p ${OUTPUT_FULL}
- run: mkdir -p ${LOG_FULL}

exec_methods:
- name: singularity
  if:
  - in_path: singularity
  exec:
  - type: singularity
    image: docker://quay.io/biocontainers/bowtie2:2.4.1--py37h8270d21_3
    run: bowtie2-build
    args:
    - flag: --threads
      value: ${THREADS}
    - mount: ${REFERENCE}
    - mount: ${OUTPUT}
      value: ${OUTPUT_BASE}/reference
    stdout: ${LOG_FULL}/${OUTPUT_BASE}-bowtie2-build.stdout
    stderr: ${LOG_FULL}/${OUTPUT_BASE}-bowtie2-build.stderr

- name: environment
  if:
  - in_path: bowtie2-build
  exec:
  - run: bowtie2-build
    args:
    - flag: --threads'
      value: ${THREADS}'
    - value: ${REFERENCE_FULL}'
    - value: ${OUTPUT_FULL}/reference'
    stdout: ${LOG_FULL}/${OUTPUT_BASE}-bowtie2-build.stdout
    stderr: ${LOG_FULL}/${OUTPUT_BASE}-bowtie2-build.stderr

post_exec:
